//+------------------------------------------------------------------+
//|                                          TRUE_SCALPER_tdavid.mq4 |
//|                                   Copyright  2006, Yousky Soft. |
//|                                            http://yousky.free.fr |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+
extern double Lots = 0.1;
extern double StopLoss = 15;
extern double TakeProfit = 15;
extern double TrailingStop = 10;
extern double PipBuffer = 2;
extern double ProfitMade = 2;
extern double slippage = 2;

//+------------------------------------------------------------------+
//| Special Convertion Functions                                     |
//+------------------------------------------------------------------+

int LastTradeTime;



int MOrderSend( string symbol, int cmd, double volume, double price, int slippage, double stoploss, double takeprofit, string comment="", int magic=0, datetime expiration=0, color arrow_color=CLR_NONE)
  {
  LastTradeTime = CurTime();
  price = MathRound(price*10000)/10000;
  stoploss = MathRound(stoploss*10000)/10000;
  takeprofit = MathRound(takeprofit*10000)/10000;
  return ( OrderSend( symbol, cmd, volume, price, slippage, stoploss, takeprofit, comment, magic, expiration, arrow_color ) );
  }

int OrderValueTicket(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderTicket());
}

int OrderValueType(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderType());
}

double OrderValueLots(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderLots());
}

double OrderValueOpenPrice(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderOpenPrice());
}



double OrderValueClosePrice(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderClosePrice());
}


string OrderValueSymbol(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderSymbol());
}



//+------------------------------------------------------------------+
//| End                                                              |
//+------------------------------------------------------------------+

int start()
{
//+------------------------------------------------------------------+
//| Local variables                                                  |
//+------------------------------------------------------------------+
double OpenTrades = 0;
double bull = 0;
double bear = 0;
double RSIPOS = 0;
double RSINEG = 0;
double BuyIt = 0;
double SellIt = 0;
double sl = 0;
double tp = 0;
int i = 0;
int cnt = 0;
double vtime = 0;

/*[[
	Name := TRUE_SCALPER_tdavid
	Author := 
	Link := .PointForex/
	Notes := long if EMA3>EMA7:::EMA3<EMA7<0 Adapted from Robot Scalper by MC to use EMA and RSI
	Notes := multiple currencies, 
	Lots := 1
	Stop Loss := 15
	Take Profit := 50
	Trailing Stop := 0
]]*/


         

           OpenTrades = 0;
           bull       = iMA(NULL, 0, 3, 0, MODE_EMA, PRICE_CLOSE, 1);
           bear       = iMA(NULL, 0, 7, 0, MODE_EMA, PRICE_CLOSE, 1);
           RSIPOS     = iRSI(NULL, 0, 2, PRICE_CLOSE, 2)>50;
           RSINEG     = iRSI(NULL, 0, 2, PRICE_CLOSE, 2)<50;
           BuyIt      = (Ask+(PipBuffer*Point));
           SellIt     = (Bid-(PipBuffer*Point));

if( (CurTime()-LastTradeTime)<10 ) return(0);

for(i =1;i <=OrdersTotal();i ++) {
  if( OrderValueSymbol(i) == Symbol() ) 
   OpenTrades++;
 }

for(cnt=1;cnt<=OrdersTotal();cnt++) {
  if( OrderValueType(cnt) == OP_BUY && OrderValueSymbol(cnt) == Symbol() ) 
   {
    if( (Bid-OrderValueOpenPrice(cnt))>(ProfitMade*Point) ) 
     {
      OrderClose(OrderValueTicket(cnt),OrderValueLots(cnt),OrderValueClosePrice(cnt),0,Cyan);
      return(0);
     }
   }
  if( OrderValueType(cnt) == OP_SELL && OrderValueSymbol(cnt) == Symbol() ) 
   {
    if( (OrderValueOpenPrice(cnt)-Ask)>(ProfitMade*Point) ) 
     {
      OrderClose(OrderValueTicket(cnt),OrderValueLots(cnt),OrderValueClosePrice(cnt),0,Fuchsia);
      return(0);
     }
   }
 }

if( OpenTrades<1 ) 
 {
  if( ((bull>bear)&&(RSINEG)&&(BuyIt<OpenTrades)) ) 
   {
    sl=(Ask-(StopLoss*Point));
    tp=(Bid+(TakeProfit*Point));
    MOrderSend(Symbol(),OP_BUY,Bid,Ask,slippage,sl,tp,"",16384,0,Cyan);
    vtime=Time[0];
    return(0);
   }
  if( ((bull<bear)&&(RSIPOS)&&(SellIt>OpenTrades)) ) 
   {
    sl=(Bid+(StopLoss*Point));
    tp=(Ask-(TakeProfit*Point));
    MOrderSend(Symbol(),OP_SELL,Bid,Bid,slippage,sl,tp,"",16384,0,Fuchsia);
    vtime=Time[0];
    return(0);
   }
 }

if( ((OpenTrades == 1)&&(vtime != Time[0])) ) 
 {
  if( ((bull>bear)&&(RSINEG)&&(BuyIt<OpenTrades)) ) 
   {
    sl=(Ask-(StopLoss*Point));
    tp=(Bid+(TakeProfit*Point));
    MOrderSend(Symbol(),OP_BUY,Bid,Ask,slippage,sl,tp,"",16384,0,Cyan);
    vtime=Time[0];
    return(0);
   }
  if( ((bull<bear)&&(RSIPOS)&&(SellIt>OpenTrades)) ) 
   {
    sl=(Bid+(StopLoss*Point));
    tp=(Ask-(TakeProfit*Point));
    MOrderSend(Symbol(),OP_SELL,Bid,Bid,slippage,sl,tp,"",16384,0,Fuchsia);
    vtime=Time[0];
    return(0);
   }
 }  return(0);
}